;Neo-Geo Music Hack by Chris Covell, May-October 2016

;==============================================================
; WLA-DX banking setup
;==============================================================
.MEMORYMAP
 SLOTSIZE $10000
 DEFAULTSLOT 0
 SLOT 0 $0000
 SLOT 1 $4000
 SLOT 2 $8000
.ENDME
.ROMBANKMAP
 BANKSTOTAL 1
 BANKSIZE $10000
 BANKS 1
.ENDRO

.BACKGROUND "in_005-m1.m1"

;F F F F A A A A A A B ?
;0 1 2 3 4 5 6 7 8 9 A
;If channel 0 is left out, the tempo goes down the drain.

.DEFINE START_CHAN	$0
.DEFINE END_CHAN        $A

.DEFINE FM_KILL		0
.DEFINE PCMA_KILL	0




.bank 0 slot 0
.org $0000
;==============================================================
; Boot section
;==============================================================

.orga $0200			;If we skip channels, change starting reading pos.
	.db START_CHAN*2+$0E

.orga $038E		;This is where the pointers to song #16 ($10) start!
.orga $0390		;track 01
 .dw Track_1_MML
 .dw Track_2_MML
 .dw Track_3_MML
 .dw Track_4_MML	;First ADPCM track
 .dw Track_5_MML
 .dw Track_6_MML
 .dw Track_7_MML
 .dw Track_8_MML
 .dw Track_9_MML        ;last ADPCM-A track
 .dw Track_A_MML	;ADPCM-B track
 .dw 0

;.orga $11E9	;Song 8 -> has pitch bends & unused data...
;.orga $11EC    	;Loop start
;	.db "R"
;.orga $128B
;	.db "RR"	;Loop end

;Level 1 song from $1939
;(ADPCM) track 4 from $1E13-$1E5D
;ADPCM-B from $1f1b-$1f88


;////////////// BLANK OUT SOME MUSIC TRACKS FOR SONG 16!! ////////////
.orga $1939		;FM 0
	;I'll let the code do its own instrument setting up here.

.orga $193D
 .db "T",73	;65	;Set tempo here
 .db "V",$5F
.include "BigBlue-LeadA.asm"

;;.orga $1ae9
Track_1_MML:
;; .db $ff     ;FM Channel 1 start
 .db "(?",$4A,"O",4,"V",$4F
.include "BigBlue-AccompB.asm"

;;.orga $1c96
Track_2_MML:
;; .db $ff     ;FM 2
 .db "(?",$4A,"O",4,"V",$4F
.include "BigBlue-AccompA.asm"

;;.orga $1cf5
Track_3_MML:
;; .db $ff	;FM 3
 .db "(?",$4A,"O",4
.include "BigBlue-bass.asm"


;;.orga $1e13	;PCMA 0
Track_4_MML:
 .db "U",$3F,"(?",1,"V",$1F	;commands at start of this track
;;.orga $1e1b	;PCMA 0
.include "BigBlue-perc.asm"

.IF 1==1
;.orga $1e13 .db $ff	;PCMA 0
;.orga $1e5e
Track_5_MML:
 .db $ff
;.orga $1e93
Track_6_MML:
 .db $ff
;.orga $1ec6
Track_7_MML:
 .db $ff
;.orga $1f19
Track_8_MML:
 .db $ff	;PCMA 4 "unused"
;.orga $1f1a
Track_9_MML:
 .db $ff	;PCMA 5	"unused"
.ENDIF

Track_A_MML:
;.orga $1f1b .db $ff     ;ADPCM B
 .db "(?",$0B 			;$0B= Choir sample
 .db "V", $6f
.include "BigBlue-ADPCMB.asm"











;/////////////////////////////////////////////////////////////////////
 ; DO YOU DARE TO LOOK BEHIND THE CURTAIN?

; 3rd track from $2124
;.orga $212b .db $7b,$99,"RRRRRRRRRRRRRRRRRRR",$7d

;.orga $2274 .db $ff	;FM 1
;.orga $23b1 .db $ff	;FM 2
;.orga $24e1 .db $ff	;FM 3
;.orga $25cf .db $ff	;ADPCM A 0
;.orga $26b8 .db $ff
;.orga $273f .db $ff
;.orga $2814 .db $ff
;.orga $2855	;blank
;.orga $2856	;blank
;.orga $2857 .db $ff	;ADPCM B


.orga $d2b4
	.dw START_CHAN*$40+$f900
.orga $d2b8
	.dw START_CHAN*$40+$f900

.orga $d2d9			;Change how many channels to do.
	.db END_CHAN-START_CHAN+1

.orga $ec6c
	call PortCheck_ADtoC
	nop
	nop
	nop
	nop		;Disables both port writes

.orga $ec7e
	call PortCheck_ADtoC
	nop
	nop
	nop
	nop		;Disables both port writes


.IF PCMA_KILL == 1
.orga $ee32		;Control some ADPCM volume here
	call PortCheck1_ABtoC
	nop
	nop
	nop
	nop
	nop
	nop		;Disables both port writes
.ENDIF


;.orga $ee5f		;Neither of these seems to have a deep effect...
;	call PortCheck2_IXtoC
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop
;	nop		;Disables both port writes



;.orga	$ee9d			;This has some effect on ADPCMA
;	call	PortCheck3_AHLtoC
;	nop
;	nop
;	nop

;.orga	$eec1			;This too has some effect on ADPCMA
;	call	PortCheck4_IXtoC
;	nop
;	nop
;	nop
;	nop
;	nop


;.orga	$ecd9
;	call	Port6Check1
;	nop
;	;Leave the write to port 7...
;
;.orga	$ecea
;	call	Port6Check1
;	nop
;	;Leave the write to port 7...


;.orga	$eed1
;	call	PortCheck5_IXtoC
;	nop
;	nop
;	nop
;	nop
;	nop

;.orga $ef7c	;This is ld a,($f80c)
;	ld a,4
;	nop

.orga $f520

PortCheck5_IXtoC:
	out     (c),a	;Okay, gotta check if ADPCM volume is written
	inc	c

	cp	1	;Is YM address written #1?
	jr	nz,_pass_port_write_03
	ld	a,c
	cp	7	;WAS Port Written #6?
	jr	nz,_pass_port_write_03

	ld      a,4	;LOWER VOLUME
	out     (c),a
	ld      a,(ix+$1f)
	ret
_pass_port_write_03:
	ld      a,(ix+$1f)
	out     (c),a
	ret


Port6Check1:
	out     ($06),a
	inc     hl
	cp	1	;Was it master ADPCM volume?
	jr	nz,_pass_port_06_01
	ld	a,1	;Volume set very low
	ret
_pass_port_06_01:
	ld      a,(hl)
	ret


PortCheck2_IXtoC:
	out     (c),a
	inc     c

	cp	1	;Is YM address written #1?
	jr	nz,_pass_port_write_06
	ld	a,c
	cp	7	;WAS Port Written #6?
	jr	nz,_pass_port_write_06

	ld      a,4	;LOWER VOLUME
	out     (c),a
	ld      a,(ix+$38)
	and     $3f
	or      b
	ld      (ix+$38),a
	ret
_pass_port_write_06:
	ld      a,(ix+$38)
	and     $3f
	or      b
	ld      (ix+$38),a
	out     (c),a
	ret



PortCheck4_IXtoC:
	out     (c),a	;Okay, gotta check if ADPCM volume is written
	inc	c

	cp	1	;Is YM address written #1?
	jr	nz,_pass_port_write_01
	ld	a,c
	cp	7	;WAS Port Written #6?
	jr	nz,_pass_port_write_01

	ld      a,4	;LOWER VOLUME
	out     (c),a
	ld      a,(ix+$38)
	ret
_pass_port_write_01:
	ld      a,(ix+$38)
	out     (c),a
	ret


PortCheck3_AHLtoC:
	out     (c),a
	inc     c

	cp	1	;Is YM address written #1?
	jr	nz,_pass_port_write_02
	ld	a,c
	cp	7	;WAS Port Written #6?
	jr	nz,_pass_port_write_02

	ld      a,4	;LOWER VOLUME
	out     (c),a
	ld      a,(hl)
	ret
_pass_port_write_02:
	ld      a,(hl)
	out     (c),a
	ret






PortCheck1_ABtoC:		;A /should/ be 1 here
	out (c),a
	inc     c

	cp	1	;Is YM address written #1?
	jr	nz,_pass_port_write_05
	ld	a,c
	cp	7	;WAS Port Written #6?
	jr	nz,_pass_port_write_05

	ld      a,4	;LOWER VOLUME (1 is inaudible!)
	out     (c),a
	ld      a,b
	ld      ($f80c),a
	ret
_pass_port_write_05:
	ld      a,b
	ld      ($f80c),a
	out     (c),a
	ret









PortCheck_ADtoC:	;Handles FM cancellation only.
.IF FM_KILL == 0
	out (c),a
.ENDIF
	inc c
	nop
	nop
.IF FM_KILL == 0
	out (c),d
.ENDIF
	ret